-- Exp rewrite
ModCS.Npc.Act[1] = function(npc)
	if npc.act_no == 0 then
		npc.ym = math.random() * (0.25 - -0.25) + -0.25
		npc.xm = math.random() * (0.5 - 0.248046875) + 0.248046875

		npc.act_no = 1
	end

	npc.xm = npc.xm - 0.015625

	if npc.x < ModCS.Player.x - 240 then
		npc:Delete()
	end

	if npc.xm < -3 then
		npc.xm = -3
	end

	if npc:TouchLeftWall() then
		npc.xm = math.random() * (1.5 - 0.7) + 0.7
	elseif npc:TouchCeiling() then
		npc.ym = 0.125
	elseif npc:TouchFloor() then
		npc.ym = -0.125
	end


	npc:Move()

	npc.ani_wait = npc.ani_wait + 1
	if npc.ani_wait > 2 then
		npc.ani_wait = 0
		npc.ani_no = npc.ani_no + 1
		if npc.ani_no > 5 then
			npc.ani_no = 0
		end
	end


	npc:SetRect(npc.ani_no * 16, 16, 16 + (npc.ani_no * 16), 32)

	if npc.exp == 5 then
		npc:OffsetRect(0,16,0,16)
	elseif npc.exp == 20 then
		npc:OffsetRect(0,32,0,32)
	end
end

-- Force hearts to have wind property
ModCS.Npc.Act[87] = function(npc)
	if npc.act_no == 0 then
		npc.ym = math.random() * (0.25 - -0.25) + -0.25
		npc.xm = math.random() * (0.5 - 0.248046875) + 0.248046875

		npc.act_no = 1
	end
	npc.xm = npc.xm - 0.015625
	if npc:TouchLeftWall() then
		npc.xm = math.random() * (1.5 - 0.7) + 0.7
	elseif npc:TouchCeiling() then
		npc.ym = 0.125
	elseif npc:TouchFloor() then
		npc.ym = -0.125
	end

	npc:Move()

	npc:ActCode(87)
end

-- Make it so gaudis despawn after reaching hardcoded limit
ModCS.Npc.Act[154] = function(npc)
	if npc.y > 624 then
		npc:Delete()
	end
	npc:ActCode(154)
end

-- Hitmarker spawning
-- Maze Critter
ModCS.Npc.Act[147] = function(npc)
	if npc.act_no == 4 and npc.act_wait % 30 == 1 then
		ModCS.Caret.Spawn(17, ModCS.Player.x, ModCS.Player.y)
	end
	npc:ActCode(147)
end

-- Armored Gaudi
ModCS.Npc.Act[173] = function(npc)
	if npc.act_no == 25 and npc.act_wait == 25 or npc.act_wait == 35 then
		ModCS.Caret.Spawn(17, ModCS.Player.x, ModCS.Player.y)
	end
	npc:ActCode(173)
end

-- <SPS Spawner
ModCS.Npc.Act[6] = function(npc)

	npc.act_wait = npc.act_wait - 1
	if npc.act_wait == 0 then
		npc.ani_no = npc.ani_no - 1
		npc.act_wait = 30
		local n = ModCS.Npc.Spawn(7, npc.x, npc.y)
		-- Set Direction
		if npc.direct == 0 then -- Left
			n.xm = -1
		elseif npc.direct == 1 then -- Right
			n.xm = 1
		elseif npc.direct == 2 then -- Up
			n.ym = -1
		else	-- Down
			n.ym = 1
		end
	end	
	if npc.ani_no == 0 then
		npc:Delete()
		print("sps kill")
	end
end

-- Soap
ModCS.Npc.Act[7] = function(npc)

	-- Init
	if npc.act_no == 0 then
		if npc.direct ~= 0 then
			npc.act_no = 2
		end
		npc.act_no = 1

	-- Attack
	else
		-- Follow player
		if npc.x < ModCS.Player.x then
			npc.xm = npc.xm + 0.05
		else
			npc.xm = npc.xm - 0.05
		end
		if npc.y < ModCS.Player.y then
			npc.ym = npc.ym + 0.05
		else
			npc.ym = npc.ym - 0.05
		end
		-- Limit speed
		if npc.xm > 2.4 then
			npc.xm = 2.4
		elseif npc.xm < -2.4 then
			npc.xm = -2.4
		end
		if npc.ym > 2.4 then
			npc.ym = 2.4
		elseif npc.ym < -2.4 then
			npc.ym = -2.4
		end

		-- Bounce off walls
		if npc:TouchLeftWall() or npc:TouchRightWall() then
			npc.xm = -npc.xm / 0.5
		end

		-- Animate
		npc.ani_wait = npc.ani_wait + 1
		if npc.ani_wait > 3 then
			npc.ani_wait = 0
			npc.ani_no = npc.ani_no + 1
		end
		if npc.ani_no > 1 then
			npc.ani_no = 0
		end
	end

	npc:Move()

	if npc.x > ModCS.Player.x then
		npc:SetRect(96 + (npc.ani_no * 24), 176, 120 + (npc.ani_no * 24), 192)
	else
		npc:SetRect(96 + (npc.ani_no * 24), 160, 120 + (npc.ani_no * 24), 176)
	end
end

-- Gato
-- Hey, you should go to the gato summoning circle at August 30 2021 at 40°15'09"N 58°26'23"E, it's at 3:24pm EST, don't be late!
ModCS.Npc.Act[14] = function(npc)
	npc.ani_wait = npc.ani_wait + 1
	if npc.ani_wait > 70 then
		npc.ani_wait = 0
		if npc.ani_no == 0 then
			npc.ani_no = 1
		else
			npc.ani_no = 0
		end
	end
	npc:SetRect(npc.ani_no * 16, 96, 16 + (npc.ani_no * 16), 112)
end